program dsp_test

    use dsp
    use real_kinds

    implicit none
    real(sp) :: isp, jsp, ksp
    real(dp) :: idp, jdp, kdp
    real(sp) :: rthetasp, rsincsp, rrectsp
    real(dp) :: rthetadp, rsincdp, rrectdp
    integer :: ierr

    write(*,*) '----------------------------------------'
    write(*,*) '          Single precision test         '
    write(*,*) '----------------------------------------'
    print *,'Enter x, t, and tau:'
    read *, isp, jsp, ksp
    rthetasp = theta(isp)
    rsincsp = sinc(isp)
    rrectsp = rect(jsp, ksp, ierr)

    write(*,*) 'theta(', isp, ') = ', rthetasp
    write(*,*) 'sinc(', isp, ') = ', rsincsp
    if (ierr == 0) then
        write(*,*) 'rect(', jsp, ',', ksp, ') = ', rrectsp
    else
        write(0,*) 'Rect: invalid argument tau = ', ksp
        stop
    endif

    write(*,*) '----------------------------------------'
    write(*,*) '          Double precision test         '
    write(*,*) '----------------------------------------'
    print *,'Enter x, t, and tau:'
    read *, idp, jdp, kdp
    rthetadp = theta(idp)
    rsincdp = sinc(idp)
    rrectdp = rect(jdp, kdp, ierr)

    write(*,*) 'theta(', idp, ') = ', rthetadp
    write(*,*) 'sinc(', idp, ') = ', rsincdp
    if (ierr == 0) then
        write(*,*) 'rect(', jdp, ',', kdp, ') = ', rrectdp
    else
        write(0,*) 'Rect: invalid argument tau = ', kdp
        stop
    endif

end program dsp_test
